package com.zhongzheng.modules.course.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.course.domain.CourseHandoutsBusiness;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.course.bo.CourseSubjectProjectAddBo;
import com.zhongzheng.modules.course.bo.CourseSubjectProjectQueryBo;
import com.zhongzheng.modules.course.bo.CourseSubjectProjectEditBo;
import com.zhongzheng.modules.course.domain.CourseSubjectProject;
import com.zhongzheng.modules.course.mapper.CourseSubjectProjectMapper;
import com.zhongzheng.modules.course.vo.CourseSubjectProjectVo;
import com.zhongzheng.modules.course.service.ICourseSubjectProjectService;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 科目绑定项目Service业务层处理
 *
 * @author ruoyi
 * @date 2021-10-09
 */
@Service
public class CourseSubjectProjectServiceImpl extends ServiceImpl<CourseSubjectProjectMapper, CourseSubjectProject> implements ICourseSubjectProjectService {

    @Override
    public CourseSubjectProjectVo queryById(Long id){
        CourseSubjectProject db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, CourseSubjectProjectVo.class);
    }

    @Override
    public List<CourseSubjectProjectVo> queryList(CourseSubjectProjectQueryBo bo) {
        LambdaQueryWrapper<CourseSubjectProject> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getProjectId() != null, CourseSubjectProject::getProjectId, bo.getProjectId());
        lqw.eq(bo.getSubjectId() != null, CourseSubjectProject::getSubjectId, bo.getSubjectId());
        lqw.orderByDesc(CourseSubjectProject::getUpdateTime);
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<CourseSubjectProjectVo> entity2Vo(Collection<CourseSubjectProject> collection) {
        List<CourseSubjectProjectVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, CourseSubjectProjectVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<CourseSubjectProject> page = (Page<CourseSubjectProject>)collection;
            Page<CourseSubjectProjectVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(CourseSubjectProjectAddBo bo) {
        CourseSubjectProject add = BeanUtil.toBean(bo, CourseSubjectProject.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(CourseSubjectProjectEditBo bo) {
        CourseSubjectProject update = BeanUtil.toBean(bo, CourseSubjectProject.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(CourseSubjectProject entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
